package be.jeffcheasey88.peeratcode.parser.java;

import java.util.List;
import java.util.function.BiFunction;
import java.util.function.Function;

public abstract class JavaElement {

	public abstract int parse(String content, CleanerPool global, CleanerPool local) throws Exception;
	
	public abstract <E extends JavaElement> E find(Function<JavaElement, Boolean> search, Function<List<JavaElement>, Boolean> deep, List<JavaElement> trace);
	public abstract <E extends JavaElement> E find(BiFunction<JavaElement, List<JavaElement>, Boolean> search, List<JavaElement> trace);
	
	//Only for development
	public abstract void show(int tab);
}
